﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace DifferentAnalizers
{
    /// <summary>
    /// "Понятное" число (для которого не обязательно создавать константу, не Magic Number)
    /// </summary>
    [Serializable()]
    public class GoodNumber
    {
        private int value;

        [DisplayName("Число")]
        [Description("Число, которое анализатор не будет считать Magic Number")]
        public int Value { get { return value; } set { this.value = value; } }

        [Browsable(false)]
        public string Name
        {
            get
            {
                return value.ToString();
            }
        }

        public GoodNumber()
        {
            value = 0;
        }

        public GoodNumber(int Value)
        {
            value = Value;
        }

        public GoodNumber(string Value)
        {
            try
            {
                value = Convert.ToInt32(Value);
            }
            catch
            {
                value = 0;
            }
        }

        /// <summary>
        /// Сравнение с объектом
        /// </summary>
        /// <param name="obj">объект</param>
        /// <returns>результат сравнения</returns>
        public override bool Equals(object obj)
        {
            return (obj is GoodNumber) ? value.ToString().Equals((obj as GoodNumber).Value.ToString()) : base.Equals(obj);
        }
    }
}
