﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daBase.Analyser
{
    /// <summary>
    /// Аттрибут - свойства анализатора по умолчанию
    /// </summary>
    public class AnalyserDefaultSettingsAttribute : BaseAnalyserDefaultSettingsAttribute
    {
        // Сообщение и уровень важности
        private string message, hint;
        private int level;

        /// <summary>
        /// Сообщение об ошибке анализатора
        /// </summary>
        public string Message { get { return message; } }

        /// <summary>
        /// Уровень важности ошибки
        /// </summary>
        public int Level { get { return level; } }

        /// <summary>
        /// Подсказка по устранению ошибки
        /// </summary>
        public string Hint { get { return hint; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="name">имя анализатора</param>
        /// <param name="message">сообщение об ошибке анализатора</param>
        /// <param name="level">уровень важности ошибки анализатора</param>
        public AnalyserDefaultSettingsAttribute(string Name, string Message, int Level, string Hint)
            : base(Name)
        {
            message = Message;
            level = Level;
            hint = Hint;
        }
    }
}
