﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daBase.Analyser
{
    using Objects.AnalysisErrors;
    using Objects.Metrics;

    /// <summary>
    /// Базовый контроллер анализа
    /// </summary>
    public class BaseAnalysisController
    {
        /// <summary>
        /// Событие "произошла ошибка"
        /// </summary>
        public event EventHandler<ErrorArgs> ErrorOccuredEvent;

        /// <summary>
        /// Обработчик события - произошла ошибка
        /// </summary>
        /// <param name="sender">инициатор события</param>
        /// <param name="e">информация об ошибке</param>
        public virtual void ErrorOccured(object sender, ErrorArgs e)
        {
            if (ErrorOccuredEvent != null)
                ErrorOccuredEvent(sender, e);
        }

        /// <summary>
        /// Событие "Вычислена метрика"
        /// </summary>
        public event EventHandler<MetricaArgs> MetricaCalculatedEvent;

        /// <summary>
        /// Обработчик события - вычислена метрика
        /// </summary>
        /// <param name="sender">инициатор события</param>
        /// <param name="e">информация о метрике</param>
        public virtual void MetricaCalculated(object sender, MetricaArgs e)
        {
            if (MetricaCalculatedEvent != null)
                MetricaCalculatedEvent(sender, e);
        }
    }
}
