﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daBase.Objects.AnalysisErrors
{
    using Safe;

    /// <summary>
    /// Информация о проанализированном файле
    /// </summary>
    public class AnalysedFileInfo
    {
        private string name;
        private FileMap map;
        private SafeDictionary<string, string> metatags;

        /// <summary>
        /// Имя файла
        /// </summary>
        public string Name { get { return name; } }

        /// <summary>
        /// Карта файла
        /// </summary>
        public FileMap Map { get { return map; } }

        /// <summary>
        /// Мета-теги
        /// </summary>
        public SafeDictionary<string, string> MetaTags { get { return metatags; } }

        public AnalysedFileInfo(string Name, FileMap Map, SafeDictionary<string, string> MetaTags)
        {
            name = Name;
            map = Map;
            metatags = MetaTags;
        }
    }
}
