﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daBase.Objects.Safe
{
    /// <summary>
    /// Метод "если больше ничего нет" (используется в безопасный массивах для создания новых элементов, если необходимого элемента нет на нужном месте)
    /// </summary>
    /// <typeparam name="ValueType">тип создаваемого элемента</typeparam>
    /// <typeparam name="KeyType">основа для создаваемого элемента</typeparam>
    /// <param name="Key">основа</param>
    /// <returns>создаваемый элемент</returns>
    public delegate ValueType IfNoMoreMethod<ValueType, KeyType>(KeyType Key);

    /// <summary>
    /// Метод "если больше ничего нет" (используется в безопасный массивах для создания новых элементов, если необходимого элемента нет на нужном месте)
    /// </summary>
    /// <typeparam name="ValueType">тип создаваемого элемента</typeparam>
    /// <returns>создаваемый элемент</returns>
    public delegate ValueType IfNoMoreMethod<ValueType>();
}