﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace daBase.Objects.Safe
{
    /// <summary>
    /// Безопасный файл
    /// </summary>
    public class SafeFile
    {
        /// <summary>
        /// Безопасное создание директории (со всеми родительскими директориями)
        /// </summary>
        /// <param name="Directory">полный путь до директории</param>
        public static void CreateDirectory(string Directory)
        {
            DirectoryInfo directory = new DirectoryInfo(Directory);
            if (directory.Exists) return;
            CreateDirectory(directory.Parent.FullName);
            System.IO.Directory.CreateDirectory(Directory);
        }

        /// <summary>
        /// Безопасная запись в файл
        /// </summary>
        /// <param name="Filename">полный путь до файла</param>
        /// <param name="Text">текст, записываемый в файл</param>
        public static void WriteAllText(string Filename, string Text)
        {
            CreateDirectory(new FileInfo(Filename).DirectoryName);
            File.WriteAllText(Filename, Text);
        }
    }
}
