﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser
{
    using daBase.Objects;
    using SemanticTree;

    /// <summary>
    /// Ошибка семантического анализатора
    /// </summary>
    class SemanticDanalyserError : DanalyserError
    {
        private FileSemanticElement file;
        private string code;

        /// <summary>
        /// Файл, в котором обнаружена ошибка
        /// </summary>
        public FileSemanticElement File { get { return file; } set { file = value; } }

        /// <summary>
        /// Код элемента, содержащего ошибку
        /// </summary>
        public string Code { get { return code; } set { code = Code; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="File">файл, в котором обнаружена ошибка</param>
        /// <param name="Message">сообщение об ошибке</param>
        /// <param name="Code">код элемента, содержащего ошибку</param>
        public SemanticDanalyserError(FileSemanticElement File, string Message, string Code)
            : base(Message)
        {
            file = File;
            code = Code;
        }
    }
}
