﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип - массив
    /// </summary>
    public class ArrayTypeSemanticElement : TypeSemanticElement
    {
        private List<IntervalCommonTypeSemanticElement> intervals;
        private CommonTypeSemanticElement type;

        /// <summary>
        /// Измерения (интервалы)
        /// </summary>
        public List<IntervalCommonTypeSemanticElement> Intervals { get { return intervals; } set { intervals = value; } }

        /// <summary>
        /// Тип элементов массива
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Intervals">измерения (интервалы)</param>
        /// <param name="Type">тип элементов массива</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ArrayTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, List<IntervalCommonTypeSemanticElement> Intervals, TypeSemanticElement Type, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            intervals = (Intervals == null) ? new List<IntervalCommonTypeSemanticElement>() : Intervals;
            type = Type;
        }
    }
}
