﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Функция класса
    /// </summary>
    public class ClassFunctionSemanticElement : FunctionSemanticElement
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя функции</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий функцию</param>
        /// <param name="Type">тип функции (процедура, функция, конструктор ...)</param>
        /// <param name="Params">список параметров функции</param>
        /// <param name="Directives">директивы функции</param>
        /// <param name="Realization">реализация функции</param>
        /// <param name="ReturnType">тип возвращаемого значения</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ClassFunctionSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, List<ParamSemanticElement> Params, List<MethodDirectiveSemanticElement> Directives, MethodRealizationSemanticElement Realization, CommonTypeSemanticElement ReturnType, ISyntaxTreeElement SyntaxElement) : base(Name, Parent, Unit, Params, Directives, Realization, ReturnType, SyntaxElement) { }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Function">семантический элемент-функция (основа)</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ClassFunctionSemanticElement(FunctionSemanticElement Function, ISyntaxTreeElement SyntaxElement) : base(Function.Name, Function.Parent, Function.Unit, Function.Params, Function.Directives, Function.Realization, Function.ReturnType, SyntaxElement) { }
    }
}
