﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип-класс (class of)
    /// </summary>
    public class ClassOfTypeSemanticElement : ClassTypeSemanticElement
    {
        private CommonTypeSemanticElement type;

        /// <summary>
        /// Тип класса
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя класса</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий класс</param>
        /// <param name="Packed">является ли класс запакованным</param>
        /// <param name="Type">тип класса</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ClassOfTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, CommonTypeSemanticElement Type, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            type = Type;
        }
    }
}
