﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Свойство класса
    /// </summary>
    public class ClassPropertySemanticElement : InterfacePropertySemanticElement
    {
        private PropertyOptionSemanticElement implements;
        private bool enddefault;

        /// <summary>
        /// Опция implements
        /// </summary>
        public PropertyOptionSemanticElement Implements { get { return implements; } set { implements = value; } }

        /// <summary>
        /// default в конце
        /// </summary>
        public bool EndDefault { get { return enddefault; } set { enddefault = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель свойства</param>
        /// <param name="Unit">модуль, содержащий свойство</param>
        /// <param name="Indexes">индексаторы свойства</param>
        /// <param name="Type">тип свойства</param>
        /// <param name="Index">индекс</param>
        /// <param name="Read">опция read</param>
        /// <param name="Write">опция write</param>
        /// <param name="Stored">опция stored</param>
        /// <param name="Default">опция default/nodefault</param>
        /// <param name="Implements">опция implements</param>
        /// <param name="EndDefault">default в конце</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ClassPropertySemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, List<VarSemanticElement> Indexes, CommonTypeSemanticElement Type, string Index, PropertyOptionSemanticElement Read, PropertyOptionSemanticElement Write, PropertyOptionSemanticElement Stored, PropertyOptionSemanticElement Default, PropertyOptionSemanticElement Implements, bool EndDefault, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Indexes, Type, Index, Read, Write, Stored, Default, SyntaxElement)
        {
            implements = Implements;
            enddefault = EndDefault;
        }
    }
}
