﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Общий тип
    /// </summary>
    public class CommonTypeSemanticElement : UnitElementSemanticElement
    {
        private bool packed;

        /// <summary>
        /// Является ли тип запакованным
        /// </summary>
        public bool Packed { get { return packed; } set { packed = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя типа</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий тип</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public CommonTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, SyntaxElement)
        {
            packed = Packed;
        }
    }
}
