﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Константа
    /// </summary>
    public class ConstSemanticElement : UnitElementSemanticElement
    {
        private CommonTypeSemanticElement type;
        private ISyntaxTreeElement value;

        /// <summary>
        /// Тип
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Значение
        /// </summary>
        public ISyntaxTreeElement Value { get { return value; } set { this.value = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Type">тип</param>
        /// <param name="Value">значение</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ConstSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, CommonTypeSemanticElement Type, ISyntaxTreeElement Value, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, SyntaxElement)
        {
            type = Type;
            value = Value;
        }
    }
}
