﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Функция dispatch-интерфейса
    /// </summary>
    public class DispinterfaceFunctionSemanticElement : FunctionSemanticElement
    {
        private PropertyOptionSemanticElement dispid;

        /// <summary>
        /// Опция dispid
        /// </summary>
        public PropertyOptionSemanticElement Dispid { get { return dispid; } set { dispid = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя функции</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий функцию</param>
        /// <param name="Params">список параметров функции</param>
        /// <param name="Directives">директивы функции</param>
        /// <param name="Realization">реализация функции</param>
        /// <param name="ReturnType">тип возвращаемого значения</param>
        /// <param name="Dispid">опция dispid</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public DispinterfaceFunctionSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, List<ParamSemanticElement> Params, List<MethodDirectiveSemanticElement> Directives, MethodRealizationSemanticElement Realization, CommonTypeSemanticElement ReturnType, PropertyOptionSemanticElement Dispid, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Params, Directives, Realization, ReturnType, SyntaxElement)
        {
            dispid = Dispid;
        }
    }
}
