﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Процедура dispatch-интерфейса
    /// </summary>
    public class DispinterfaceProcedureSemanticElement : ProcedureSemanticElement
    {
        private PropertyOptionSemanticElement dispid;

        /// <summary>
        /// Опция dispid
        /// </summary>
        public PropertyOptionSemanticElement Dispid { get { return dispid; } set { dispid = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя процедуры</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий процедуру</param>
        /// <param name="Type">тип процедуры (процедура, функция, конструктор ...)</param>
        /// <param name="Params">список параметров процедуры</param>
        /// <param name="Directives">директивы процедуры</param>
        /// <param name="Realization">реализация процедуры</param>
        /// <param name="Dispid">опция dispid</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public DispinterfaceProcedureSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, MethodTypes Type, List<ParamSemanticElement> Params, List<MethodDirectiveSemanticElement> Directives, MethodRealizationSemanticElement Realization, PropertyOptionSemanticElement Dispid, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Type, Params, Directives, Realization, SyntaxElement)
        {
            dispid = Dispid;
        }
    }
}
