﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Перечислимый тип
    /// </summary>
    public class EnumCommonTypeSemanticElement : CommonTypeSemanticElement
    {
        private List<EnumCommonTypeValueSemanticElement> values;

        /// <summary>
        /// Элементы
        /// </summary>
        public List<EnumCommonTypeValueSemanticElement> Values { get { return values; } set { values = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя типа</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий тип</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Values">элементы</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public EnumCommonTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, List<EnumCommonTypeValueSemanticElement> Values, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            values = (Values == null) ? new List<EnumCommonTypeValueSemanticElement>() : Values;
        }
    }
}
