﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Элемент перечислимого типа
    /// </summary>
    public class EnumCommonTypeValueSemanticElement : NamedSemanticTreeElement
    {
        private ConstExpressionElement value;

        /// <summary>
        /// Значение элемента
        /// </summary>
        public ConstExpressionElement Value { get { return value; } set { this.value = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Value">значение элемента</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public EnumCommonTypeValueSemanticElement(string Name, IChildSemanticElement Parent, ConstExpressionElement Value, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, SyntaxElement)
        {
            value = Value;
        }
    }

}
