﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип - файл
    /// </summary>
    public class FileTypeSemanticElement : TypeSemanticElement
    {
        private CommonTypeSemanticElement type;

        /// <summary>
        /// Тип файла
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Type">тип файла</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public FileTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, TypeSemanticElement Type, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            type = Type;
        }
    }
}
