﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Функция
    /// </summary>
    public class FunctionSemanticElement : MethodSemanticElement
    {
        private CommonTypeSemanticElement returntype;

        /// <summary>
        /// Тип возвращаемого значения
        /// </summary>
        public CommonTypeSemanticElement ReturnType { get { return returntype; } set { returntype = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя функции</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий функцию</param>
        /// <param name="Params">список параметров функции</param>
        /// <param name="Directives">директивы функции</param>
        /// <param name="Realization">реализация функции</param>
        /// <param name="ReturnType">тип возвращаемого значения</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public FunctionSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, List<ParamSemanticElement> Params, List<MethodDirectiveSemanticElement> Directives, MethodRealizationSemanticElement Realization, CommonTypeSemanticElement ReturnType, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, MethodTypes.Function, Params, Directives, Realization, SyntaxElement)
        {
            returntype = ReturnType;
        }
    }
}
