﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Перечислимый тип (интервал)
    /// </summary>
    public class IntervalCommonTypeSemanticElement : CommonTypeSemanticElement
    {
        private ExpressionElement start;
        private ExpressionElement end;

        /// <summary>
        /// Начало интервала
        /// </summary>
        public ExpressionElement Start { get { return start; } set { start = value; } }

        /// <summary>
        /// Конец интервала
        /// </summary>
        public ExpressionElement End { get { return end; } set { end = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя типа</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий тип</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Start">начало интервала</param>
        /// <param name="End">конец интервала</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public IntervalCommonTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, ExpressionElement Start, ExpressionElement End, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            start = Start;
            end = End;
        }
    }
}
