﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Директива message
    /// </summary>
    public class MessageMethodDirectiveSemanticElement : MethodDirectiveSemanticElement
    {
        private ExpressionElement message;

        /// <summary>
        /// Сообщение
        /// </summary>
        public ExpressionElement Message { get { return message; } set { message = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Message">сообщение</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public MessageMethodDirectiveSemanticElement(IChildSemanticElement Parent, ExpressionElement Message, ISyntaxTreeElement SyntaxElement)
            : base(Parent, MethodDirectives.Message, SyntaxElement)
        {
            message = Message;
        }
    }
}
