﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Директива метода
    /// </summary>
    public class MethodDirectiveSemanticElement : SemanticTreeElement
    {
        private MethodDirectives directive;

        /// <summary>
        /// Директива
        /// </summary>
        public MethodDirectives Directive { get { return directive; } set { directive = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Directive">директива</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public MethodDirectiveSemanticElement(IChildSemanticElement Parent, MethodDirectives Directive, ISyntaxTreeElement SyntaxElement)
            : base(Parent, SyntaxElement)
        {
            directive = Directive;
        }
    }
}
