﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип-объект
    /// </summary>
    public class ObjectTypeSemanticElement : FullClassTypeSemanticElement
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя объекта</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий объект</param>
        /// <param name="Packed">является ли объект запакованным</param>
        /// <param name="Type">тип объекта (abstract/sealed)</param>
        /// <param name="ParentClass">родительский объект</param>
        /// <param name="ParentInterfaces">родительские интерфейсы</param>
        /// <param name="Private">секция private</param>
        /// <param name="StrictPrivate">секция strict private</param>
        /// <param name="Protected">секция protected</param>
        /// <param name="StrictProtected">секция strict protected</param>
        /// <param name="Public">секция public</param>
        /// <param name="Published">секция published</param>
        /// <param name="Automated">секция automated</param>
        /// <param name="Other">остальные объявления</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ObjectTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, ClassTypes Type, CommonTypeSemanticElement ParentClass, List<InterfaceTypeSemanticElement> ParentInterfaces, ClassSectionSemanticElement Private, ClassSectionSemanticElement StrictPrivate, ClassSectionSemanticElement Protected, ClassSectionSemanticElement StrictProtected, ClassSectionSemanticElement Public, ClassSectionSemanticElement Published, ClassSectionSemanticElement Automated, SectionedSemanticElement Other, ISyntaxTreeElement SyntaxElement) : base(Name, Parent, Unit, Packed, Type, ParentClass, ParentInterfaces, Private, StrictPrivate, Protected, StrictProtected, Public, Published, Automated, Other, SyntaxElement) { }
    }
}
