﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Параметр функции
    /// </summary>
    public class ParamSemanticElement : VarSemanticElement
    {
        private string modifier;

        /// <summary>
        /// Модификатор (in, out, const ...)
        /// </summary>
        public string Modifier { get { return modifier; } set { modifier = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Type">тип</param>
        /// <param name="IsPlatform">является ли переменная устаревшей (директива platform)</param>
        /// <param name="Modifier">модификатор (in, out, const ...)</param>
        /// <param name="Value">значение</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ParamSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, CommonTypeSemanticElement Type, bool IsPlatform, string Modifier, ISyntaxTreeElement Value, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Type, IsPlatform, Value, null, SyntaxElement)
        {
            modifier = Modifier;
        }
    }
}
