﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип-процедура
    /// </summary>
    public class ProcedureTypeSemanticElement : MethodTypeSemanticElement
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя процедуры</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий процедуру</param>
        /// <param name="Type">тип процедуры (процедура, конструктор ...)</param>
        /// <param name="Params">список параметров процедуры</param>
        /// <param name="OfObject">флаг наличия директивы of object</param>
        /// <param name="Directives">директивы процедуры</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ProcedureTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, MethodTypes Type, List<ParamSemanticElement> Params, bool OfObject, List<MethodDirectiveSemanticElement> Directives, ISyntaxTreeElement SyntaxElement) : base(Name, Parent, Unit, Packed, Type, Params, OfObject, Directives, SyntaxElement) { }
    }
}
