﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Опция свойства
    /// </summary>
    public class PropertyOptionSemanticElement : SemanticTreeElement, IUnitElementSemanticElement
    {
        private FileSemanticElement unit;
        private PropertyOptionTypes type;
        private UnitElementSemanticElement value;

        /// <summary>
        /// Модуль, содержащий элемент
        /// </summary>
        public FileSemanticElement Unit { get { return unit; } set { unit = value; } }

        /// <summary>
        /// Тип опции
        /// </summary>
        public PropertyOptionTypes Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Значение опции
        /// </summary>
        public UnitElementSemanticElement Value { get { return value; } set { this.value = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Type">тип опции</param>
        /// <param name="Value">значение опции</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public PropertyOptionSemanticElement(IChildSemanticElement Parent, FileSemanticElement Unit, PropertyOptionTypes Type, UnitElementSemanticElement Value, ISyntaxTreeElement SyntaxElement)
            : base(Parent, SyntaxElement)
        {
            unit = Unit;
            type = Type;
            value = Value;
        }
    }
}
