﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Блок case внутри записи
    /// </summary>
    public class RecordCaseSemanticElement : UnitElementSemanticElement
    {
        private CommonTypeSemanticElement type;
        private List<RecordCaseElementSemanticElement> elements;

        /// <summary>
        /// Тип выбираемого значения
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Элементы блока
        /// </summary>
        public List<RecordCaseElementSemanticElement> Elements{get{return elements;}set{elements=value;}}

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Type">тип выбираемого значения</param>
        /// <param name="Elements">элементы блока</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public RecordCaseSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, CommonTypeSemanticElement Type, List<RecordCaseElementSemanticElement> Elements, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, SyntaxElement)
        {
            type = Type;
            elements = (Elements == null) ? new List<RecordCaseElementSemanticElement>() : Elements;
        }
    }
}
