﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип-константная запись
    /// </summary>
    public class RecordConstTypeSemanticElement : ConstTypeSemanticElement
    {
        private List<VarSemanticElement> vars;

        /// <summary>
        /// Список переменных
        /// </summary>
        public List<VarSemanticElement> Vars { get { return vars; } set { vars = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя типа</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий тип</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Vars">список переменных</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public RecordConstTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, List<VarSemanticElement> Vars, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            vars = (Vars == null) ? new List<VarSemanticElement>() : Vars;
        }
    }
}
