﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип - ссылка на метод
    /// </summary>
    public class ReferenceToMethodTypeSemanticElement : TypeSemanticElement
    {
        private MethodTypeSemanticElement method;

        /// <summary>
        /// Метод
        /// </summary>
        public MethodTypeSemanticElement Method { get { return method; } set { method = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="Method">метод</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public ReferenceToMethodTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, MethodTypeSemanticElement Method, bool Packed, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            method = Method;
        }
    }
}
