﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Тип-синоним
    /// </summary>
    public class SynonymCommonTypeSemanticElement : CommonTypeSemanticElement
    {
        private CommonTypeSemanticElement type;

        /// <summary>
        /// Исходный тип
        /// </summary>
        public CommonTypeSemanticElement Type { get { return type; } set { type = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя типа</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий тип</param>
        /// <param name="Packed">является ли тип запакованным</param>
        /// <param name="Type">исходный тип</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public SynonymCommonTypeSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, bool Packed, CommonTypeSemanticElement Type, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, Unit, Packed, SyntaxElement)
        {
            type = Type;
        }
    }
}
