﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSemanticAnalyser.SemanticTree
{
    using daSyntaxAnalyser.SyntaxTree;

    /// <summary>
    /// Элемент модуля
    /// </summary>
    public class UnitElementSemanticElement : NamedSemanticTreeElement, IUnitElementSemanticElement
    {
        private FileSemanticElement unit;

        /// <summary>
        /// Модуль, содержащий элемент
        /// </summary>
        public FileSemanticElement Unit { get { return unit; } set { unit = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Name">имя элемента</param>
        /// <param name="Parent">родитель элемента семантического дерева</param>
        /// <param name="Unit">модуль, содержащий элемент</param>
        /// <param name="SyntaxElement">соответствующий элемент синтаксического дерева</param>
        public UnitElementSemanticElement(string Name, IChildSemanticElement Parent, FileSemanticElement Unit, ISyntaxTreeElement SyntaxElement)
            : base(Name, Parent, SyntaxElement)
        {
            unit = Unit;
        }
    }
}
