﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace daStaticAnalyser.Analysers
{
    using Settings;

    /// <summary>
    /// Анализатор проверки идентификатора
    /// </summary>
    public abstract class IdAnalyser : BaseStaticAnalyser
    {
        /// <summary>
        /// Идентификаторы из dfm-файла - хорошие
        /// </summary>
        [Category("Особые")]
        [DisplayName("Исключать dfm")]
        [Description("Если данная опция включена, то идентификаторы из подключенного к модулю dfm-файла будут исключены из анализа")]
        public bool DfmIsGood { get { return (settings as IdSettings).DfmIsGood; } set { (settings as IdSettings).DfmIsGood = value; } }

        protected override void Init()
        {
            if (settings == null)
                settings = new IdSettings();
            base.Init();
        }
    }
}
