﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daStaticAnalyser.Analysers.Settings
{
    // Объекты
    using daBase.Objects.AnalysisErrors;
    using daBase.Analyser;

    /// <summary>
    /// Настройки анализатора
    /// </summary>
    [Serializable()]
    public class AnalyserSettings : BaseAnalyserSettings
    {
        // Свойства
        private string message;
        private Importance level = new Importance();

        /// <summary>
        /// Сообщение анализатора об ошибке
        /// </summary>
        public string Message { get { return message; } set { message = value; } }

        /// <summary>
        /// Уровень важности ошибки
        /// </summary>
        public int Level { get { return level.Value; } set { level.Value = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Enabled">анализатор включен</param>
        /// <param name="Message">сообщение об ошибке анализатора</param>
        /// <param name="Level">уровень важности ошибки</param>
        public AnalyserSettings(bool Enabled, string Message, int Level)
            : base(Enabled)
        {
            message = Message;
            level = new Importance(Level);
        }

        /// <summary>
        /// Конструктор (по умолчанию)
        /// </summary>
        public AnalyserSettings() : this(true, "Ошибка анализа!", 100) { }
    }
}
