﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.Analysers.DfmAnalyser
{
    /// <summary>
    /// Класс dfm токен
    /// </summary>
    public class DfmTokenInfo
    {
        private DfmTokens token;
        private string text;
        private int line;

        /// <summary>
        /// Dfm-токен
        /// </summary>
        public DfmTokens Token { get { return token; } }

        /// <summary>
        /// Текст токена
        /// </summary>
        public string Text { get { return text; } }

        /// <summary>
        /// Номер строки, содержащей токен
        /// </summary>
        public int Line { get { return line; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="token">dfm-токен</param>
        /// <param name="text">текст токена</param>
        /// <param name="line">номер строки, содержащей токен</param>
        public DfmTokenInfo(DfmTokens token, string text, int line)
        {
            this.token = token;
            this.text = text;
            this.line = line;
        }

        /// <summary>
        /// Преобразование к строковому типу
        /// </summary>
        /// <returns>соответствующая строка</returns>
        public override string ToString()
        {
            return text;
        }
    }
}
