﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Блок asm
    /// </summary>
    class AsmStatementElement : StatementElement
    {
        private string content;

        /// <summary>
        /// Содержимое блока
        /// </summary>
        public string Content{get{return content;}set{content=value;}}

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="StartInfo">информация о позиции элемента</param>
        /// <param name="Content">содержимое asm-блока</param>
        /// <param name="Comments">комментарии, принадлежащие элементу</param>
        public AsmStatementElement(TokenInfo StartInfo, string Content, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            content = Content;
        }
    }
}
