﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    public class AssignmentElement : StatementElement
    {
        private VariableExpressionElement variable;
        private ExpressionElement expression;

        public VariableExpressionElement Variable { get { return variable; } set { variable = value; } }
        public ExpressionElement Expression { get { return expression; } set { expression = value; } }

        public AssignmentElement(TokenInfo StartInfo, VariableExpressionElement Variable, ExpressionElement Expression, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            variable = Variable;
            expression = Expression;
        }

        public override string ToString()
        {
            return string.Format("{0} := {1}", variable, expression);
        }

        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            yield return variable;
            yield return expression;
        }
    }
}
