﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Блок else внутри case
    /// </summary>
    public class CaseElseStatementElement : CompoundStatementElement
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="StartInfo">информация о позиции элемента в коде</param>
        /// <param name="Statements">команды внутри блока кода</param>
        /// <param name="Comments">комментарии, относящиеся к элементу</param>
        public CaseElseStatementElement(TokenInfo StartInfo, List<StatementsElement> Statements, List<TokenInfo> Comments) : base(StartInfo, Statements, Comments) { }

        /// <summary>
        /// Представление элемента в строковом формате
        /// </summary>
        /// <returns>строковое представление элемента</returns>
        public override string ToString()
        {
            return string.Format("{0}else\r\n{1}", CommentsString(), InnerStatements());
        }
    }
}
