﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Директива метода (stdcall, safecall, ...)
    /// </summary>
    public class DirectiveElement : SyntaxTreeElement
    {
        private TokenInfo token;

        /// <summary>
        /// Директива
        /// </summary>
        public TokenInfo Token { get { return token; } set { token = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Token">директива</param>
        /// <param name="Comments">комментарии, относящиеся к элементу</param>
        public DirectiveElement(TokenInfo Token, List<TokenInfo> Comments)
            : base(Token, Comments)
        {
            token = Token;
        }

        /// <summary>
        /// Представление элемента в строковом формате
        /// </summary>
        /// <returns>строковое представление элемента</returns>
        public override string ToString()
        {
            return token.ToString();
        }
    }
}
