﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Элемент синтаксического дерева
    /// </summary>
    public interface ISyntaxTreeElement : IEnumerable<ISyntaxTreeElement>
    {
        /// <summary>
        /// Информация о позиции элемента в коде
        /// </summary>
        TokenInfo StartInfo { get; }

        /// <summary>
        /// Комментарии
        /// </summary>
        List<TokenInfo> Comments { get; }
    }
}
