﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Идентификатор
    /// </summary>
    public class IdElement : SyntaxTreeElement
    {
        protected TokenInfo id;

        /// <summary>
        /// Идентификатор
        /// </summary>
        public TokenInfo Id { get { return id; } set { id = value; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Id">идентификатор</param>
        /// <param name="Comments">комментарии, относящиеся к элементу</param>
        public IdElement(TokenInfo Id, List<TokenInfo> Comments)
            : base(Id, Comments)
        {
            id = Id;
        }

        /// <summary>
        /// Представление элемента в строковом формате
        /// </summary>
        /// <returns>строковое представление элемента</returns>
        public override string ToString()
        {
            return id.Text;
        }
    }
}
