﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    public class IndexExternalOptionElement : ExternalOptionElement
    {
        private ExpressionElement value;

        public ExpressionElement Value { get { return value; } set { this.value = value; } }

        public IndexExternalOptionElement(TokenInfo Token, ExpressionElement Value, List<TokenInfo> Comments)
            : base(Token, Comments)
        {
            value = Value;
        }

        public override string ToString()
        {
            return string.Format("index {0}", value);
        }

        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            yield return value;
        }
    }
}
