﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Унарное выражение, в котором оператор стоит в правой части
    /// </summary>
    public class IndirectionUnaryExpressionElement : UnaryExpressionElement
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="Type">тип выражения (оператор)</param>
        /// <param name="Operand">операнд</param>
        /// <param name="Comments">комментарии, относящиеся к элементу</param>
        public IndirectionUnaryExpressionElement(TokenInfo Type, ExpressionElement Operand, List<TokenInfo> Comments)
            : base(Type, Operand, Comments)
        {
            startinfo = Operand.StartInfo;
        }

        /// <summary>
        /// Представление элемента в строковом формате
        /// </summary>
        /// <returns>строковое представление элемента</returns>
        public override string ToString()
        {
            return string.Format("{1}{0}", type, operand);
        }
    }
}
