﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    public class PackedConstTypeElement : SyntaxTreeElement, ISimpleConstTypeElement
    {
        private IConstTypeElement type;

        public IConstTypeElement Type { get { return type; } set { type = value; } }

        public PackedConstTypeElement(TokenInfo StartInfo, IConstTypeElement Type, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            type = Type;
        }

        public override string ToString()
        {
            return string.Format("packed {0}", type);
        }

        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            yield return type;
        }
    }
}
