﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    /// <summary>
    /// Адрес операнда
    /// </summary>
    public class PointerToVariableExpressionElement : VariableExpressionElement
    {
        private VariableExpressionElement variable;

        /// <summary>
        /// Операнд
        /// </summary>
        public VariableExpressionElement Variable { get { return variable; } set { variable = variable; } }

        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="StartInfo">информация о позиции элемента в коде</param>
        /// <param name="Variable">операнд</param>
        /// <param name="Comments">комментарии, относящиеся к элементу</param>
        public PointerToVariableExpressionElement(TokenInfo StartInfo, VariableExpressionElement Variable, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            variable = Variable;
        }

        /// <summary>
        /// Представление элемента в строковом формате
        /// </summary>
        /// <returns>строковое представление элемента</returns>
        public override string ToString()
        {
            return string.Format("@{0}", variable);
        }

        /// <summary>
        /// Создание типизированного энумератора
        /// </summary>
        /// <returns>энумератор</returns>
        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            yield return variable;
        }
    }
}
