﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    public class RecordConstTypeElement : SyntaxTreeElement, ISimpleConstTypeElement
    {
        private List<VarDeclarationElement> elements;

        public List<VarDeclarationElement> Elements { get { return elements; } set { elements = value; } }

        public RecordConstTypeElement(TokenInfo StartInfo, List<VarDeclarationElement> Elements, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            elements = Elements;
        }

        public override string ToString()
        {
            return string.Format("record{0}\r\nend", ((elements != null) && (elements.Count > 0)) ? string.Format("\r\n{0}", Tabulate(elements.Join("\r\n"))) : string.Empty);
        }

        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            if (elements != null)
                foreach (VarDeclarationElement element in elements)
                    yield return element;
        }
    }
}
