﻿using System;
using System.Collections.Generic;
using System.Text;

namespace daSyntaxAnalyser.SyntaxTree
{
    using daBase.Objects;

    public class SetCommonTypeElement : SyntaxTreeElement, ICommonTypeElement
    {
        private ICommonTypeElement type;

        public ICommonTypeElement Type { get { return type; } set { type = value; } }

        public SetCommonTypeElement(TokenInfo StartInfo, ICommonTypeElement Type, List<TokenInfo> Comments)
            : base(StartInfo, Comments)
        {
            type = Type;
        }

        public override string ToString()
        {
            return string.Format("set of {0}", type);
        }

        protected override IEnumerator<ISyntaxTreeElement> CreateEnumerator()
        {
            yield return type;
        }
    }
}
