﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace danalyser.Interface.Dialogs
{
    // Контроллеры
    using danalyser.Controllers;

    /// <summary>
    /// Форма поиска
    /// </summary>
    public partial class SearchForm : Form
    {
        public SearchForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Поиск текста
        /// </summary>
        public void findBtn_Click(object sender, EventArgs e)
        {
            if ((sText.Text.Length > 0) && (FormController.Instance.Editor.codeBox.Text.Length > 0))
            {
                int p = FormController.Instance.Editor.codeBox.SelectionStart + 1;
                if (p < FormController.Instance.Editor.codeBox.Text.Length)
                {
                    StringComparison c = (rLook.Checked) ? StringComparison.Ordinal : StringComparison.OrdinalIgnoreCase;
                    if (sDown.Checked && (p + 1 < FormController.Instance.Editor.codeBox.Text.Length))
                    {
                        int i = FormController.Instance.Editor.codeBox.Text.IndexOf(sText.Text, p, c);
                        if (i > 0)
                        {
                            FormController.Instance.Editor.codeBox.SelectionStart = i;
                            FormController.Instance.Editor.codeBox.SelectionLength = sText.Text.Length;
                            FormController.Instance.Editor.codeBox.Focus();
                            FormController.Instance.Editor.codeBox.ScrollToCaret();
                            FormController.Instance.Editor.codeBox.Refresh();
                        }
                    }
                    else if (sUp.Checked && (p > 1))
                    {
                        string sub = FormController.Instance.Editor.codeBox.Text.Substring(0, p - 1);
                        int i = sub.LastIndexOf(sText.Text, c);
                        if (i > 0)
                        {
                            FormController.Instance.Editor.codeBox.SelectionStart = i;
                            FormController.Instance.Editor.codeBox.SelectionLength = sText.Text.Length;
                            FormController.Instance.Editor.codeBox.Focus();
                            FormController.Instance.Editor.codeBox.ScrollToCaret();
                            FormController.Instance.Editor.codeBox.Refresh();
                        }
                    }
                }
            }
            FormController.Instance.Editor.Activate();
        }

        /// <summary>
        /// Выход
        /// </summary>
        private void cancelBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Скрытие формы вместо закрытия
        /// </summary>
        private void SearchForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = (e.CloseReason == CloseReason.UserClosing);
            if (e.Cancel) Hide();
        }

        /// <summary>
        /// Поиск
        /// </summary>
        private void sText_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Return)
                findBtn_Click(this, new EventArgs());
        }
    }
}
